; Teamspeak Wrapper fr BlitzBasic
; Copyright  Christian Klaussner, 2008

Include "Constants.bb"

Const TS_PLAYER_INFO_SIZE = 50
Const TS_CHANNEL_INFO_SIZE = 50
Const TS_SERVER_INFO_SIZE = 482
Const TS_CLIENT_INFO_SIZE = 16

; Spielerdaten

Type TS_PLAYER_INFO
	Field PlayerID, ChannelID
	Field NickName$
	Field ChannelPrivileges
	Field PlayerPrivileges
	Field PlayerFlags
End Type

Global TS_PlayerCount
Dim TS_PlayerArray.TS_PLAYER_INFO( 0 )

Type TS_PLAYER_INFO_ID
	Field PlayerID, ChannelID
	Field NickName$
	Field ChannelPrivileges
	Field PlayerPrivileges
	Field PlayerFlags
End Type

; Ruft die Daten fr einen Spieler mit der angegebenen ID ab
; und speichert sie im Type info.

Function TS_GetPlayerInfoFromID( id, info.TS_PLAYER_INFO_ID )
	Local bank = CreateBank( TS_PLAYER_INFO_SIZE )
	tsrGetPlayerInfoByID id, bank
	
	info\PlayerID			= PeekInt( bank, 0 )
	info\ChannelID			= PeekInt( bank, 4 )
	info\NickName			= StringFromBank( bank, 8, 30 )
	info\ChannelPrivileges	= PeekInt( bank, 38 )
	info\PlayerPrivileges	= PeekInt( bank, 42 )
	info\PlayerFlags		= PeekInt( bank, 46 )
	
	FreeBank bank
	
	Return 1
End Function

Function TS_DeletePlayerInfoID( info.TS_PLAYER_INFO_ID )
	Delete info
	
	Return 1
End Function

; Ruft die Daten fr alle Spieler ab. Die Anzahl der Spieler
; lsst sich mit TS_GetPlayerInfo ermitteln. Die Daten werden
; im Array TS_PlayerArray gespeichert.

Function TS_GetPlayerInfo( )
	Local bank = CreateBank( TS_PLAYER_INFO_SIZE * 1024 )
	
	Local records = CreateBank( 4 )
	PokeInt records, 0, 1024
	
	tsrGetPlayers bank, records
	
	TS_PlayerCount = PeekInt( records, 0 )
	Dim TS_PlayerArray( TS_PlayerCount )
	
	Local offset
	For I=0 To TS_PlayerCount-1
		TS_PlayerArray(I) = New TS_PLAYER_INFO
		
		TS_PlayerArray(I)\PlayerID			= PeekInt( bank, 0 + offset )
		TS_PlayerArray(I)\ChannelID			= PeekInt( bank, 4 + offset )
		TS_PlayerArray(I)\NickName			= StringFromBank( bank, 8 + offset, 30 )
		TS_PlayerArray(I)\ChannelPrivileges	= PeekInt( bank, 38 + offset )
		TS_PlayerArray(I)\PlayerPrivileges	= PeekInt( bank, 42 + offset )
		TS_PlayerArray(I)\PlayerFlags		= PeekInt( bank, 46 + offset )
		
		offset = offset + TS_PLAYER_INFO_SIZE
	Next
	
	FreeBank bank
	FreeBank records
	
	Return 1
End Function

Function TS_GetPlayerCount( )
	Return TS_PlayerCount
End Function

Function TS_DeletePlayerInfo( )
	For I.TS_PLAYER_INFO = Each TS_PLAYER_INFO
		Delete I
	Next
	
	Return 1
End Function

; Channelinfo

Type TS_CHANNEL_INFO
	Field ChannelID
	Field ParentID
	Field PlayerCount
	Field ChannelFlags
	Field Codec
	Field Name$
End Type

Global TS_ChannelCount
Dim TS_ChannelArray.TS_CHANNEL_INFO( 0 )

Type TS_CHANNEL_INFO_ID
	Field ChannelID
	Field ParentID
	Field PlayerCount
	Field ChannelFlags
	Field Codec
	Field Name$
End Type

; Ruft die Daten fr einen Channel mit der angegebenen ID ab
; und speichert sie im Type info.

Function TS_GetChannelInfoFromID( id, info.TS_CHANNEL_INFO_ID )
	Local bank = CreateBank( TS_CHANNEL_INFO_SIZE )
	tsrGetChannelInfoByID id, bank, 0, 0
	
	info\ChannelID		= PeekInt( bank, 0 )
	info\ParentID		= PeekInt( bank, 4 )
	info\PlayerCount	= PeekInt( bank, 8 )
	info\ChannelFlags	= PeekInt( bank, 12 )
	info\Codec			= PeekInt( bank, 16 )
	info\Name			= StringFromBank( bank, 20, 30 )
	
	FreeBank bank
	
	Return 1
End Function

Function TS_DeleteChannelInfoID( info.TS_CHANNEL_INFO_ID )
	Delete info
	
	Return 1
End Function

; Ruft die Daten fr alle Channel ab. Die Anzahl der Channel
; lsst sich mit TS_GetChannelCount ermitteln. Die Daten werden
; im Array TS_ChannelArray gespeichert.

Function TS_GetChannelInfo( )
	Local bank = CreateBank( TS_CHANNEL_INFO_SIZE * 1024 )
	
	Local records = CreateBank( 4 )
	PokeInt records, 0, 1024
	
	tsrGetChannels bank, records
	
	TS_ChannelCount = PeekInt( records, 0 )
	Dim TS_ChannelArray( TS_ChannelCount )
	
	Local offset
	For I=0 To TS_ChannelCount-1
		TS_ChannelArray(I) = New TS_CHANNEL_INFO
		
		TS_ChannelArray(I)\ChannelID	= PeekInt( bank, 0 + offset )
		TS_ChannelArray(I)\ParentID		= PeekInt( bank, 4 + offset )
		TS_ChannelArray(I)\PlayerCount	= PeekInt( bank, 8 + offset )
		TS_ChannelArray(I)\ChannelFlags	= PeekInt( bank, 12 + offset )
		TS_ChannelArray(I)\Codec		= PeekInt( bank, 16 + offset )
		TS_ChannelArray(I)\Name			= StringFromBank( bank, 20 + offset, 30 )
		
		offset = offset + TS_CHANNEL_INFO_SIZE
	Next
	
	FreeBank bank
	FreeBank records
	
	Return 1
End Function

Function TS_GetChannelCount( )
	Return TS_ChannelCount
End Function

Function TS_DeleteChannelInfo( )
	For I.TS_CHANNEL_INFO = Each TS_CHANNEL_INFO
		Delete I
	Next
	
	Return 1
End Function

; Speakerinfo

Global TS_SpeakerCount
Dim TS_SpeakerArray( 0 )

; Ruft die IDs fr alle sprechenden Spieler ab. Die Anzahl der Sprecher
; lsst sich mit TS_GetSpeakerCount ermitteln. Die IDs werden
; im Array TS_SpeakerArray gespeichert.

Function TS_GetSpeakerInfo( )
	Local bank = CreateBank( 4 * 1024 )
	
	Local records = CreateBank( 4 )
	PokeInt records, 0, 1024
	
	tsrGetSpeakers bank, records
	
	TS_SpeakerCount = PeekInt( records, 0 )
	Dim TS_SpeakerArray( TS_SpeakerCount )
	
	For I=0 To TS_SpeakerCount-1
		TS_SpeakerArray(I) = PeekInt( bank, I*4 )
	Next
	
	FreeBank bank
	FreeBank records
	
	Return 1
End Function

Function TS_GetSpeakerCount( )
	Return TS_SpeakerCount
End Function

; Userinfo

Type TS_USER_INFO
	Field Player.TS_PLAYER_INFO
	Field Channel.TS_CHANNEL_INFO
	Field Parent.TS_CHANNEL_INFO
End Type

; Ruft die Daten fr den Benutzer ( Spieler, der den lokalen Client nutzt ) ab
; und speichert sie im Type info.

Function TS_GetUserInfo( info.TS_USER_INFO )
	info\Player = New TS_PLAYER_INFO
	info\Channel = New TS_CHANNEL_INFO
	info\Parent = New TS_CHANNEL_INFO
	
	Local bank = CreateBank( TS_PLAYER_INFO_SIZE + TS_CHANNEL_INFO_SIZE * 2 )
	tsrGetUserInfo bank
	
	info\Player\PlayerID			= PeekInt( bank, 0 )
	info\Player\ChannelID			= PeekInt( bank, 4 )
	info\Player\NickName			= StringFromBank( bank, 8, 30 )
	info\Player\ChannelPrivileges	= PeekInt( bank, 38 )
	info\Player\PlayerPrivileges	= PeekInt( bank, 42 )
	info\Player\PlayerFlags			= PeekInt( bank, 46 )
	
	info\Channel\ChannelID			= PeekInt( bank, 50 )
	info\Channel\ParentID			= PeekInt( bank, 54 )
	info\Channel\PlayerCount		= PeekInt( bank, 58 )
	info\Channel\ChannelFlags		= PeekInt( bank, 62 )
	info\Channel\Codec				= PeekInt( bank, 66 )
	info\Channel\Name				= StringFromBank( bank, 70, 30 )
	
	info\Parent\ChannelID			= PeekInt( bank, 100 )
	info\Parent\ParentID			= PeekInt( bank, 104 )
	info\Parent\PlayerCount			= PeekInt( bank, 108 )
	info\Parent\ChannelFlags		= PeekInt( bank, 112 )
	info\Parent\Codec				= PeekInt( bank, 116 )
	info\Parent\Name				= StringFromBank( bank, 120, 30 )
	
	FreeBank bank
	
	Return 1
End Function

Function TS_DeleteUserInfo( info.TS_USER_INFO )
	Delete info\Player
	Delete info\Channel
	Delete info\Parent
	
	Delete info
	
	Return 1
End Function

; Serverdaten

Type TS_SERVER_INFO
	Field ServerName$
	Field WelcomeMessage$
	Field Major, Minor, Release, Build
	Field Platform$
	Field ServerIP$
	Field ServerHost$
	Field ServerType
	Field MaxUsers
	Field Codecs
	Field ChannelCount
	Field PlayerCount
End Type

; Ruft die Daten fr den Server, mit dem der Client verbunden ist, ab
; und speichert sie im Type info.

Function TS_GetServerInfo( info.TS_SERVER_INFO )
	Local bank = CreateBank( 482 )
	tsrGetServerInfo bank
	
	info\ServerName		= StringFromBank( bank, 0, 30 )
	info\WelcomeMessage	= StringFromBank( bank, 30, 256 )
	info\Major			= PeekInt( bank, 286 )
	info\Minor			= PeekInt( bank, 290 )
	info\Release		= PeekInt( bank, 294 )
	info\Build			= PeekInt( bank, 298 )
	info\Platform		= StringFromBank( bank, 302, 30 )
	info\ServerIP		= StringFromBank( bank, 332, 30 )
	info\ServerHost		= StringFromBank( bank, 362, 100 )
	info\ServerType		= PeekInt( bank, 462 )
	info\MaxUsers		= PeekInt( bank, 466 )
	info\Codecs			= PeekInt( bank, 470 )
	info\ChannelCount	= PeekInt( bank, 474 )
	info\PlayerCount	= PeekInt( bank, 478 )
	
	FreeBank bank
	
	Return 1
End Function

Function TS_DeleteServerInfo( info.TS_SERVER_INFO )
	Delete info
	
	Return 1
End Function

; Versionsinfo

Type TS_VERSION_INFO
	Field Major, Minor, Release, Build
End Type

; Ruft die Versionsdaten fr den lokalen Client ab
; und speichert sie im Type info.

Function TS_GetVersionInfo( info.TS_VERSION_INFO )
	tsrGetVersion info
	
	Return 1
End Function

Function TS_DeleteVersionInfo( info.TS_VERSION_INFO )
	Delete info
	
	Return 1
End Function

; Erstellt einen String dem angegebenen Bereich einer Bank.

Function StringFromBank$( bank, offset, max )
	Local s$
	
	For I=0 To max-1
		Local b = PeekByte( bank, I+offset )
		If b = 0 Exit
		
		s = s + Chr( b )
	Next
	
	Return s
End Function